import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends ScaleCanvas implements MouseListener,MouseMotionListener {
    Manager M;
    ListenSquare GO,STOP,RANDOM,CONTROL,CONTROL2;
    ControlPanelColor DISPLAY,DIAL,BASICS;
    ControlPanel MOTION;
    SelectColor SC;
    Complex SOURCE2;
    SelectInteger[] POINT=new SelectInteger[5];
    ListenSquare CLEAR,CYCLE,SEND,GRAB;
    PolygonWrapper MEMORY;



     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 Color[] COL0={new Color(100,0,0),Color.blue,Color.white};
	 Color[] COL1={new Color(0,0,100),Color.blue,Color.white};
	 setPanels();
	 SC=new SelectColor(this.M,0,240,499,59);
	 setScales(100,500,100);
	 SOURCE2=new Complex(0,0);
	 for(int i=0;i<2;++i) POINT[i]=new SelectInteger(350,150+50*i,40,20,5,0,10,1);
	 CYCLE=new ListenSquare(270,170,50,20);
	 CLEAR=new ListenSquare(270,200,50,20);
	 SEND=new ListenSquare(170,170,50,20);
	 GRAB=new ListenSquare(170,200,50,20);
	 initialGrab();
     }


    public void initialGrab() {
	MEMORY=new PolygonWrapper();
	MEMORY.z[0]=new Complex(1,.4);
	MEMORY.z[1]=new Complex(2,1.5);
	MEMORY.z[2]=new Complex(0,2);
	MEMORY.z[3]=new Complex(.3,1.2);
    }
    



    public void setPanels() {
	Color[] C0={Color.blue,Color.white,Color.white,Color.white,Color.red};

	Color[] DisplayColor={
	    new Color(0,0,0),
            new Color(255,0,0),
            new Color(255,220,0),
            new Color(0,200,0),
            new Color(0,200,200),
	    new Color(170,0,255,150),
	    new Color(255,200,0),
            new Color(0,255,255),
            new Color(0,200,0),
            new Color(255,0,255),
	    new Color(255,0,255),
	    new Color(0,0,0)};

	String[] DisplayString={
              "------",
              "interval1",
              "interval2",
              "interval3",
              "interval4",
              "hyperbola",
	      "rectangle",
	      "partner rectangle",
	      "rectangle chain",
              "display"};

	int[] DisplayState={0,0,0,0,0,0,1,0,0,0};
        DISPLAY=new ControlPanelColor(C0,DisplayString,DisplayState,9,DisplayColor);


	Color[] BasicsColor={
	    new Color(0,0,0),
            new Color(255,0,0),
            new Color(255,220,0),
            new Color(0,200,0),
            new Color(0,200,200),
            new Color(255,0,255),
	    new Color(200,0,200),
	    new Color(255,255,255)};

	String[] BasicsString={
              "bg",
              "line1",
              "line2",
              "line3",
              "line4",
	      "diagonal \u221E",
	      "diagonal 0",
	      "quad",
              "basics"};

	int[] BasicsState={0,1,1,1,1,0,0,1,0,0};

	
        BASICS=new ControlPanelColor(C0,BasicsString,BasicsState,8,BasicsColor);

	
	Color[] DialColor={
	    new Color(255,255,255),
	    new Color(0,0,0),
            new Color(255,255,0),
	    new Color(0,0,0),
	    new Color(0,0,0),
	    new Color(0,0,0),
	    new Color(0,0,0)};
	
	String[] DialString={
              "hyp center",
              "hyp anchor",
              "hyp geodesic",
	      "AR markers",
	      "hyp ctr record",
	      "anchor record",
	      "swivel property",
              "dial"};

	int[] DialState={1,1,1,1,0,0,0};
	
        DIAL=new ControlPanelColor(C0,DialString,DialState,7,DialColor);

	
	String[] MotionString={
              "poly vertices",
	      "translate diags",
              "swivel 1",
              "swivel 2",
              "swivel 3",
              "swivel 4",
              "line selection"};
	int[] MotionState={1,0,0,0,0,0,0,0};
        MOTION=new ControlPanel(C0,MotionString,MotionState,6);
	
    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      boolean test=M.P.specialComponent();
      drawBG(g);
      drawControls(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(120,0,120));
        g.fillRect(0,0,getWidth(),getHeight()); 
	String[] S={"interval thickness","rectangle center"};
	for(int i=0;i<2;++i) {
             POINT[i].render(g,Color.red,Color.white,Color.white);
	     g.drawString(S[i],POINT[i].x,POINT[i].y-5);
	}
    }	


    public void drawControls(Graphics2D g) {
	BASICS.render(g,5,5,120);
	DISPLAY.render(g,130,5,120);
	DIAL.render(g,255,5,120);
	MOTION.render(g,380,5,100);
	SC.render(g);
	CLEAR.render(g,"clear",15,0,new Color(0,180,0));
	CYCLE.render(g,"cycle",15,0,new Color(150,0,150));
	SEND.render(g,"send",15,0,new Color(150,0,150));
	GRAB.render(g,"grab",15,0,new Color(150,0,150));
    }

    public void doClear() {
	M.S.COUNT=0;
    }


    public void doSend() {
	M.P.POLY=new PolygonWrapper(MEMORY.z);
	M.P.R1=MEMORY.diagonal(0);
	M.P.R2=MEMORY.diagonal(1);
	M.P.setSegments();
    }

    public void doGrab() {
	MEMORY=new PolygonWrapper(M.P.POLY.z);
    }


    

    public void doCycle() {
	Complex[] r1=new Complex[4];
	Complex[] r2=new Complex[4];
	r1[0]=new Complex(M.P.R2.z[1]);
	r1[1]=new Complex(M.P.R2.z[2]);
	r1[2]=new Complex(M.P.R2.z[3]);
	r1[3]=new Complex(M.P.R2.z[0]);
	r2[0]=new Complex(M.P.R1.z[1]);
	r2[1]=new Complex(M.P.R1.z[2]);
	r2[2]=new Complex(M.P.R1.z[3]);
	r2[3]=new Complex(M.P.R1.z[0]);
	M.P.R1=new PolygonWrapper(r1);
	M.P.R2=new PolygonWrapper(r2);
	M.P.setSegments();
    }
    

    public void mouseClicked(MouseEvent e) {
	MouseData J=MouseData.process(e);
	SC.process(e);
	int doc=0;
	doc=BASICS.process(J.X,SC.C);
	if(doc==20) DocInstructions.basics(M.D);
	doc=DISPLAY.process(J.X,SC.C);
	if(doc==20) DocInstructions.display(M.D);
	doc=DIAL.process(J.X,SC.C);
	if(doc==20) DocInstructions.dial(M.D);
	MOTION.switchMode(J.X);

	for(int i=0;i<2;++i) POINT[i].modify(J.X);
	if(CLEAR.inside(J.X)==1) doClear();
       	if(CYCLE.inside(J.X)==1) doCycle();
	if(SEND.inside(J.X)==1)  doSend();
	if(GRAB.inside(J.X)==1)  doGrab();

	M.repaint();
    }

    public void mousePressed(MouseEvent e) {
    }
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   
     public void mouseMoved(MouseEvent e) {}    
     public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
	SC.process(e);
	M.repaint();
     }

}

