import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;

public class Segment {
    Complex[] z=new Complex[2];


    public Segment(Complex[] w) {
	this.z=w;
    }

    public Segment(Complex z0,Complex z1) {
	z[0]=new Complex(z0);
	z[1]=new Complex(z1);
    }

    public static Complex cross(Segment S,Segment T) {
	Complex z=Vector.findCross(S.z[0],S.z[1],T.z[0],T.z[1]);
	return z;
    }

    public void render(Graphics2D g,PictureCanvas P,Color C,int t) {
	Path2D.Double gp=toPath(100);
	gp=P.transform(gp);
	g.setColor(C);
	g.setStroke(new BasicStroke(t));
	g.fill(gp);
	g.draw(gp);
    }

    
    public Path2D.Double toPath(double L) {
	Path2D.Double gp=new Path2D.Double();
	Complex[] w=new Complex[2];
	w[0]=new Complex();
	w[1]=new Complex();
	double LL=-L+1;
	w[0].x=LL*z[0].x+L*z[1].x;
	w[0].y=LL*z[0].y+L*z[1].y;
	w[1].x=LL*z[1].x+L*z[0].x;
	w[1].y=LL*z[1].y+L*z[0].y;
	gp.moveTo(w[0].x,w[0].y);
	gp.lineTo(w[1].x,w[1].y);
	return gp;
    }

    public Complex center() {
	return Complex.interpolate(z,.5);
    }

    public double slope() {
	    double d=(z[0].y-z[1].y)/(z[0].x-z[1].x);
	    return d;
    }

    public double yIntercept() {
	double t=z[0].x/(z[0].x-z[1].x);
	double y=(1-t)*z[0].y+t*z[1].y;
	return y;
    }

    public static double crossRatio(Segment[] S) {
	double[] d=new double[4];
	for(int i=0;i<4;++i) d[i]=S[i].slope();
	return crossRatio(d);
    }

    public static double crossRatio(double[] d) {
	double x1=(d[0]-d[1])*(d[2]-d[3]);
	double x2=(d[1]-d[2])*(d[3]-d[0]);
	double y=x2/x1;
	return y;
    }

}


